package com.hua.valid;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.lang.Dict;
import cn.hutool.core.util.StrUtil;
import cn.hutool.extra.expression.ExpressionUtil;
import com.hua.annotation.Handles;
import com.hua.valid.annotation.ConditionNotNull;

import java.util.Map;

/**
 * @author Hua
 * @since 2024/7/18 下午2:43
 */
@Handles(ConditionNotNull.class)
public class ConditionNotNullHandler implements AnnotationHandler {
    @Override
    public boolean handle(HandleDTO handleDTO) {
        ConditionNotNull conditionValidate = (ConditionNotNull) handleDTO.getCurrentAnnotation();
        String expression = conditionValidate.expression();
        if (StrUtil.isEmpty(expression)) {
            return true;
        }
        if (handleDTO.getField() == null) {
            return true;
        }
        Dict context = new Dict();

        Map<String, Object> fieldMap = BeanUtil.beanToMap(handleDTO.getOriginObj(), false, true);
        context.putAll(fieldMap);

        try {
            Object fieldValue = BeanUtil.getFieldValue(handleDTO.getOriginObj(), handleDTO.getField().getName());
            context.set(handleDTO.getField().getName(), fieldValue);
        } catch (Exception e) {
            throw new RuntimeException("Unable to access field value", e);
        }

        Boolean value = (Boolean) ExpressionUtil.eval(expression, context);
        if (Boolean.TRUE.equals(value) && handleDTO.getFieldValue() == null) {
            handleDTO.getErrorMessage().addErrorObj(conditionValidate.message(), handleDTO.getField());
            return false;
        }

        return true;
    }
}
